<script lang="ts">
import GitApiCall from '@/api/gitApi'
import type { Project } from '@/api/gitlabHelperApi/projectsApi'
import ProjectsApi from '@/api/gitlabHelperApi/projectsApi'
import PipelineListComponent from '@/components/gitlab/PipelineListComponent.vue'
import { computed, onMounted, ref, watch } from 'vue'
import { useStore } from 'vuex'

interface Group {
  id: string
  name: string
}

export default {
  name: 'SearchPipeline',
  components: {
    PipelineListComponent,
  },
  setup() {
    const store = useStore()
    const user = ref<{ username: string; rol: string }>({ username: '', rol: '' })
    const groups = ref<Group[]>([])
    const groupSelected = ref<string | null>(null)
    const projectOptions = ref<{ value: number | null; text: string }[]>([])
    const projectSelected = ref<number | null>(null)
    const selectedProject = ref<Project | null>(null)
    const gitApi = new GitApiCall()

    const loadingGroups = ref(true)
    const loadingProjects = ref(false)

    // Computed property to transform groups into options for v-select
    const groupOptions = computed(() => {
      return groups.value.map((group: { id: string; name: string }) => ({
        value: group.id,
        text: group.name,
      }))
    })

    watch(groupSelected, (newGroupId: string) => {
      projectSelected.value = null // Reset project selection
      if (newGroupId)
        getProjectOptions(newGroupId)
    })

    watch(projectSelected, async (newProjectId: number) => {
      if (newProjectId)
        await getProject(newProjectId)
      else
        selectedProject.value = null // Clear the selected project if none is selected
    })

    onMounted(() => {
      user.value = store.state.user
      getGroups()
    })

    async function getGroups() {
      try {
        const response = await gitApi.getGroups(false)

        groups.value = response.data
      }
      catch (error) {
        console.error('Error fetching groups: ', error)
      }
      finally {
        loadingGroups.value = false // Stop loading when groups are fetched
      }
    }

    async function getProjectOptions(groupId: string) {
      loadingProjects.value = true // Start loading projects
      try {
        const response = await gitApi.getProjectsFromGroup(groupId)

        projectOptions.value = response.data.map((project: Project) => ({
          value: project.id,
          text: project.name,
        }))
      }
      catch (error) {
        console.error('Error fetching projects: ', error)
      }
      finally {
        loadingProjects.value = false // Stop loading when projects are fetched
      }
    }

    async function getProject(projectId: number) {
      const projectsApi = new ProjectsApi()

      try {
        const response = await projectsApi.getProject(projectId)

        selectedProject.value = response.data.data
      }
      catch (error) {
        console.error('Error fetching project details: ', error)
      }
    }

    return {
      user,
      groups,
      groupSelected,
      projectOptions,
      projectSelected,
      groupOptions,
      loadingGroups,
      loadingProjects,
      getProjectOptions,
      selectedProject,
    }
  },
}
</script>

<template>
  <div>
    <!-- Card Component -->
    <VCard class="flex-card">
      <VCardTitle>
        <h5>Select Project and Group</h5>
      </VCardTitle>
      <VCardText>
        <VContainer>
          <VRow>
            <!-- Group Selection -->
            <VCol
              cols="12"
              md="6"
              class="mb-md-0 mb-2"
            >
              <VSelect
                v-if="!loadingGroups"
                v-model="groupSelected"
                :items="groupOptions"
                item-value="value"
                item-title="text"
                label="Group"
                placeholder="Please select some group"
                class="w-100"
              />
              <VProgressCircular
                v-else
                indeterminate
                color="primary"
                class="mx-auto"
              />
            </VCol>

            <!-- Project Selection -->
            <VCol
              cols="12"
              md="6"
              class="mb-md-0 mb-2"
            >
              <VSelect
                v-if="!loadingProjects"
                v-model="projectSelected"
                :items="projectOptions"
                item-value="value"
                item-title="text"
                label="Project"
                placeholder="Please select some project"
                :disabled="!groupSelected"
                class="w-100"
              />
              <VProgressCircular
                v-else
                indeterminate
                color="primary"
                class="mx-auto"
              />
            </VCol>
          </VRow>
        </VContainer>
      </VCardText>
    </VCard>

    <!-- Separator -->
    <VDivider class="my-4" />

    <!-- Pipeline Table -->
    <div class="card mb-0">
      <PipelineListComponent :project="project" />
    </div>
  </div>
</template>

<style scoped>
.flex-card {
  margin: auto;
}
</style>
